diff --git a/snf-pithos-tools/pithos/tools/lib/fuse.py b/snf-pithos-tools/pithos/tools/lib/fuse.py
index 9f30715..7c5752c 100644
--- a/snf-pithos-tools/pithos/tools/lib/fuse.py
+++ b/snf-pithos-tools/pithos/tools/lib/fuse.py
@@ -1,9 +1,9 @@
 # Copyright (c) 2008 Giorgos Verigakis <verigak@gmail.com>
-# 
+#
 # Permission to use, copy, modify, and distribute this software for any
 # purpose with or without fee is hereby granted, provided that the above
 # copyright notice and this permission notice appear in all copies.
-# 
+#
 # THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES
 # WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
 # MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR
@@ -27,15 +27,18 @@ from traceback import print_exc
 class c_timespec(Structure):
     _fields_ = [('tv_sec', c_long), ('tv_nsec', c_long)]
 
+
 class c_utimbuf(Structure):
     _fields_ = [('actime', c_timespec), ('modtime', c_timespec)]
 
+
 class c_stat(Structure):
     pass    # Platform dependent
 
 _system = system()
 if _system in ('Darwin', 'FreeBSD'):
-    _libiconv = CDLL(find_library("iconv"), RTLD_GLOBAL)     # libfuse dependency
+    _libiconv = CDLL(
+        find_library("iconv"), RTLD_GLOBAL)     # libfuse dependency
     ENOTSUP = 45
     c_dev_t = c_int32
     c_fsblkcnt_t = c_ulong
@@ -46,9 +49,9 @@ if _system in ('Darwin', 'FreeBSD'):
     c_pid_t = c_int32
     c_uid_t = c_uint32
     setxattr_t = CFUNCTYPE(c_int, c_char_p, c_char_p, POINTER(c_byte),
-        c_size_t, c_int, c_uint32)
+                           c_size_t, c_int, c_uint32)
     getxattr_t = CFUNCTYPE(c_int, c_char_p, c_char_p, POINTER(c_byte),
-        c_size_t, c_uint32)
+                           c_size_t, c_uint32)
     c_stat._fields_ = [
         ('st_dev', c_dev_t),
         ('st_ino', c_uint32),
@@ -73,9 +76,11 @@ elif _system == 'Linux':
     c_off_t = c_longlong
     c_pid_t = c_int
     c_uid_t = c_uint
-    setxattr_t = CFUNCTYPE(c_int, c_char_p, c_char_p, POINTER(c_byte), c_size_t, c_int)
-    getxattr_t = CFUNCTYPE(c_int, c_char_p, c_char_p, POINTER(c_byte), c_size_t)
-    
+    setxattr_t = CFUNCTYPE(
+        c_int, c_char_p, c_char_p, POINTER(c_byte), c_size_t, c_int)
+    getxattr_t = CFUNCTYPE(
+        c_int, c_char_p, c_char_p, POINTER(c_byte), c_size_t)
+
     _machine = machine()
     if _machine == 'x86_64':
         c_stat._fields_ = [
@@ -146,8 +151,11 @@ class c_statvfs(Structure):
 if _system == 'FreeBSD':
     c_fsblkcnt_t = c_uint64
     c_fsfilcnt_t = c_uint64
-    setxattr_t = CFUNCTYPE(c_int, c_char_p, c_char_p, POINTER(c_byte), c_size_t, c_int)
-    getxattr_t = CFUNCTYPE(c_int, c_char_p, c_char_p, POINTER(c_byte), c_size_t)
+    setxattr_t = CFUNCTYPE(
+        c_int, c_char_p, c_char_p, POINTER(c_byte), c_size_t, c_int)
+    getxattr_t = CFUNCTYPE(
+        c_int, c_char_p, c_char_p, POINTER(c_byte), c_size_t)
+
     class c_statvfs(Structure):
         _fields_ = [
             ('f_bavail', c_fsblkcnt_t),
@@ -160,6 +168,7 @@ if _system == 'FreeBSD':
             ('f_flag', c_ulong),
             ('f_frsize', c_ulong)]
 
+
 class fuse_file_info(Structure):
     _fields_ = [
         ('flags', c_int),
@@ -172,6 +181,7 @@ class fuse_file_info(Structure):
         ('fh', c_uint64),
         ('lock_owner', c_uint64)]
 
+
 class fuse_context(Structure):
     _fields_ = [
         ('fuse', c_voidp),
@@ -180,6 +190,7 @@ class fuse_context(Structure):
         ('pid', c_pid_t),
         ('private_data', c_voidp)]
 
+
 class fuse_operations(Structure):
     _fields_ = [
         ('getattr', CFUNCTYPE(c_int, c_char_p, POINTER(c_stat))),
@@ -198,8 +209,9 @@ class fuse_operations(Structure):
         ('utime', c_voidp),     # Deprecated, use utimens
         ('open', CFUNCTYPE(c_int, c_char_p, POINTER(fuse_file_info))),
         ('read', CFUNCTYPE(c_int, c_char_p, POINTER(c_byte), c_size_t, c_off_t,
-            POINTER(fuse_file_info))),
-        ('write', CFUNCTYPE(c_int, c_char_p, POINTER(c_byte), c_size_t, c_off_t,
+                           POINTER(fuse_file_info))),
+        (
+            'write', CFUNCTYPE(c_int, c_char_p, POINTER(c_byte), c_size_t, c_off_t,
             POINTER(fuse_file_info))),
         ('statfs', CFUNCTYPE(c_int, c_char_p, POINTER(c_statvfs))),
         ('flush', CFUNCTYPE(c_int, c_char_p, POINTER(fuse_file_info))),
@@ -210,18 +222,24 @@ class fuse_operations(Structure):
         ('listxattr', CFUNCTYPE(c_int, c_char_p, POINTER(c_byte), c_size_t)),
         ('removexattr', CFUNCTYPE(c_int, c_char_p, c_char_p)),
         ('opendir', CFUNCTYPE(c_int, c_char_p, POINTER(fuse_file_info))),
-        ('readdir', CFUNCTYPE(c_int, c_char_p, c_voidp, CFUNCTYPE(c_int, c_voidp,
-            c_char_p, POINTER(c_stat), c_off_t), c_off_t, POINTER(fuse_file_info))),
+        (
+            'readdir', CFUNCTYPE(c_int, c_char_p, c_voidp, CFUNCTYPE(c_int, c_voidp,
+            c_char_p, POINTER(
+                c_stat), c_off_t), c_off_t, POINTER(fuse_file_info))),
         ('releasedir', CFUNCTYPE(c_int, c_char_p, POINTER(fuse_file_info))),
-        ('fsyncdir', CFUNCTYPE(c_int, c_char_p, c_int, POINTER(fuse_file_info))),
+        ('fsyncdir', CFUNCTYPE(c_int, c_char_p, c_int, POINTER(
+            fuse_file_info))),
         ('init', CFUNCTYPE(c_voidp, c_voidp)),
         ('destroy', CFUNCTYPE(c_voidp, c_voidp)),
         ('access', CFUNCTYPE(c_int, c_char_p, c_int)),
-        ('create', CFUNCTYPE(c_int, c_char_p, c_mode_t, POINTER(fuse_file_info))),
-        ('ftruncate', CFUNCTYPE(c_int, c_char_p, c_off_t, POINTER(fuse_file_info))),
+        ('create', CFUNCTYPE(c_int, c_char_p, c_mode_t, POINTER(
+            fuse_file_info))),
+        ('ftruncate', CFUNCTYPE(c_int, c_char_p, c_off_t, POINTER(
+            fuse_file_info))),
         ('fgetattr', CFUNCTYPE(c_int, c_char_p, POINTER(c_stat),
-            POINTER(fuse_file_info))),
-        ('lock', CFUNCTYPE(c_int, c_char_p, POINTER(fuse_file_info), c_int, c_voidp)),
+                               POINTER(fuse_file_info))),
+        ('lock', CFUNCTYPE(
+            c_int, c_char_p, POINTER(fuse_file_info), c_int, c_voidp)),
         ('utimens', CFUNCTYPE(c_int, c_char_p, POINTER(c_utimbuf))),
         ('bmap', CFUNCTYPE(c_int, c_char_p, c_size_t, POINTER(c_ulonglong)))]
 
@@ -229,6 +247,7 @@ class fuse_operations(Structure):
 def time_of_timespec(ts):
     return ts.tv_sec + ts.tv_nsec / 10 ** 9
 
+
 def set_st_attrs(st, attrs):
     for key, val in attrs.items():
         if key in ('st_atime', 'st_mtime', 'st_ctime'):
@@ -262,12 +281,12 @@ class FUSE(object):
     """This class is the lower level interface and should not be subclassed
        under normal use. Its methods are called by fuse.
        Assumes API version 2.6 or later."""
-    
+
     def __init__(self, operations, mountpoint, raw_fi=False, **kwargs):
         """Setting raw_fi to True will cause FUSE to pass the fuse_file_info
            class as is to Operations, instead of just the fh field.
            This gives you access to direct_io, keep_cache, etc."""
-        
+
         self.operations = operations
         self.raw_fi = raw_fi
         args = ['fuse']
@@ -280,21 +299,21 @@ class FUSE(object):
         kwargs.setdefault('fsname', operations.__class__.__name__)
         args.append('-o')
         args.append(','.join(key if val == True else '%s=%s' % (key, val)
-            for key, val in kwargs.items()))
+                             for key, val in kwargs.items()))
         args.append(mountpoint)
         argv = (c_char_p * len(args))(*args)
-        
+
         fuse_ops = fuse_operations()
         for name, prototype in fuse_operations._fields_:
             if prototype != c_voidp and getattr(operations, name, None):
                 op = partial(self._wrapper_, getattr(self, name))
                 setattr(fuse_ops, name, prototype(op))
         err = _libfuse.fuse_main_real(len(args), argv, pointer(fuse_ops),
-            sizeof(fuse_ops), None)            
+                                      sizeof(fuse_ops), None)
         del self.operations     # Invoke the destructor
         if err:
             raise RuntimeError(err)
-    
+
     def _wrapper_(self, func, *args, **kwargs):
         """Decorator for the methods that follow"""
         try:
@@ -304,40 +323,40 @@ class FUSE(object):
         except:
             print_exc()
             return -EFAULT
-    
+
     def getattr(self, path, buf):
         return self.fgetattr(path, buf, None)
-    
+
     def readlink(self, path, buf, bufsize):
         ret = self.operations('readlink', path)
         data = create_string_buffer(ret[:bufsize - 1])
         memmove(buf, data, len(data))
         return 0
-    
+
     def mknod(self, path, mode, dev):
         return self.operations('mknod', path, mode, dev)
-    
+
     def mkdir(self, path, mode):
         return self.operations('mkdir', path, mode)
-    
+
     def unlink(self, path):
         return self.operations('unlink', path)
-    
+
     def rmdir(self, path):
         return self.operations('rmdir', path)
-    
+
     def symlink(self, source, target):
         return self.operations('symlink', target, source)
-    
+
     def rename(self, old, new):
         return self.operations('rename', old, new)
-    
+
     def link(self, source, target):
         return self.operations('link', target, source)
-    
+
     def chmod(self, path, mode):
         return self.operations('chmod', path, mode)
-    
+
     def chown(self, path, uid, gid):
         # Check if any of the arguments is a -1 that has overflowed
         if c_uid_t(uid + 1).value == 0:
@@ -345,10 +364,10 @@ class FUSE(object):
         if c_gid_t(gid + 1).value == 0:
             gid = -1
         return self.operations('chown', path, uid, gid)
-    
+
     def truncate(self, path, length):
         return self.operations('truncate', path, length)
-    
+
     def open(self, path, fip):
         fi = fip.contents
         if self.raw_fi:
@@ -356,7 +375,7 @@ class FUSE(object):
         else:
             fi.fh = self.operations('open', path, fi.flags)
             return 0
-    
+
     def read(self, path, buf, size, offset, fip):
         fh = fip.contents if self.raw_fi else fip.contents.fh
         ret = self.operations('read', path, size, offset, fh)
@@ -365,12 +384,12 @@ class FUSE(object):
         data = create_string_buffer(ret[:size], size)
         memmove(buf, data, size)
         return size
-    
+
     def write(self, path, buf, size, offset, fip):
         data = string_at(buf, size)
         fh = fip.contents if self.raw_fi else fip.contents.fh
         return self.operations('write', path, data, offset, fh)
-    
+
     def statfs(self, path, buf):
         stv = buf.contents
         attrs = self.operations('statfs', path)
@@ -378,23 +397,23 @@ class FUSE(object):
             if hasattr(stv, key):
                 setattr(stv, key, val)
         return 0
-    
+
     def flush(self, path, fip):
         fh = fip.contents if self.raw_fi else fip.contents.fh
         return self.operations('flush', path, fh)
-    
+
     def release(self, path, fip):
         fh = fip.contents if self.raw_fi else fip.contents.fh
         return self.operations('release', path, fh)
-    
+
     def fsync(self, path, datasync, fip):
         fh = fip.contents if self.raw_fi else fip.contents.fh
         return self.operations('fsync', path, datasync, fh)
-    
+
     def setxattr(self, path, name, value, size, options, *args):
         data = string_at(value, size)
         return self.operations('setxattr', path, name, data, options, *args)
-    
+
     def getxattr(self, path, name, value, size, *args):
         ret = self.operations('getxattr', path, name, *args)
         retsize = len(ret)
@@ -404,7 +423,7 @@ class FUSE(object):
                 return -ERANGE
             memmove(value, buf, retsize)
         return retsize
-    
+
     def listxattr(self, path, namebuf, size):
         ret = self.operations('listxattr', path)
         buf = create_string_buffer('\x00'.join(ret)) if ret else ''
@@ -414,15 +433,15 @@ class FUSE(object):
                 return -ERANGE
             memmove(namebuf, buf, bufsize)
         return bufsize
-    
+
     def removexattr(self, path, name):
         return self.operations('removexattr', path, name)
-    
+
     def opendir(self, path, fip):
         # Ignore raw_fi
         fip.contents.fh = self.operations('opendir', path)
         return 0
-    
+
     def readdir(self, path, buf, filler, offset, fip):
         # Ignore raw_fi
         for item in self.operations('readdir', path, fip.contents.fh):
@@ -438,24 +457,24 @@ class FUSE(object):
             if filler(buf, name, st, offset) != 0:
                 break
         return 0
-    
+
     def releasedir(self, path, fip):
         # Ignore raw_fi
         return self.operations('releasedir', path, fip.contents.fh)
-    
+
     def fsyncdir(self, path, datasync, fip):
         # Ignore raw_fi
         return self.operations('fsyncdir', path, datasync, fip.contents.fh)
-    
+
     def init(self, conn):
         return self.operations('init', '/')
-    
+
     def destroy(self, private_data):
         return self.operations('destroy', '/')
-    
+
     def access(self, path, amode):
         return self.operations('access', path, amode)
-    
+
     def create(self, path, mode, fip):
         fi = fip.contents
         if self.raw_fi:
@@ -463,11 +482,11 @@ class FUSE(object):
         else:
             fi.fh = self.operations('create', path, mode)
             return 0
-    
+
     def ftruncate(self, path, length, fip):
         fh = fip.contents if self.raw_fi else fip.contents.fh
         return self.operations('truncate', path, length, fh)
-    
+
     def fgetattr(self, path, buf, fip):
         memset(buf, 0, sizeof(c_stat))
         st = buf.contents
@@ -475,11 +494,11 @@ class FUSE(object):
         attrs = self.operations('getattr', path, fh)
         set_st_attrs(st, attrs)
         return 0
-    
+
     def lock(self, path, fip, cmd, lock):
         fh = fip.contents if self.raw_fi else fip.contents.fh
         return self.operations('lock', path, fh, cmd, lock)
-    
+
     def utimens(self, path, buf):
         if buf:
             atime = time_of_timespec(buf.contents.actime)
@@ -488,7 +507,7 @@ class FUSE(object):
         else:
             times = None
         return self.operations('utimens', path, times)
-    
+
     def bmap(self, path, blocksize, idx):
         return self.operations('bmap', path, blocksize, idx)
 
@@ -497,46 +516,46 @@ class Operations(object):
     """This class should be subclassed and passed as an argument to FUSE on
        initialization. All operations should raise a FuseOSError exception
        on error.
-       
+
        When in doubt of what an operation should do, check the FUSE header
        file or the corresponding system call man page."""
-    
+
     def __call__(self, op, *args):
         if not hasattr(self, op):
             raise FuseOSError(EFAULT)
         return getattr(self, op)(*args)
-        
+
     def access(self, path, amode):
         return 0
-    
+
     bmap = None
-    
+
     def chmod(self, path, mode):
         raise FuseOSError(EROFS)
-    
+
     def chown(self, path, uid, gid):
         raise FuseOSError(EROFS)
-    
+
     def create(self, path, mode, fi=None):
         """When raw_fi is False (default case), fi is None and create should
            return a numerical file handle.
            When raw_fi is True the file handle should be set directly by create
            and return 0."""
         raise FuseOSError(EROFS)
-    
+
     def destroy(self, path):
         """Called on filesystem destruction. Path is always /"""
         pass
-    
+
     def flush(self, path, fh):
         return 0
-    
+
     def fsync(self, path, datasync, fh):
         return 0
-    
+
     def fsyncdir(self, path, datasync, fh):
         return 0
-    
+
     def getattr(self, path, fh=None):
         """Returns a dictionary with keys identical to the stat C structure
            of stat(2).
@@ -544,33 +563,33 @@ class Operations(object):
            NOTE: There is an incombatibility between Linux and Mac OS X concerning
            st_nlink of directories. Mac OS X counts all files inside the directory,
            while Linux counts only the subdirectories."""
-        
+
         if path != '/':
             raise FuseOSError(ENOENT)
         return dict(st_mode=(S_IFDIR | 0755), st_nlink=2)
-    
+
     def getxattr(self, path, name, position=0):
         raise FuseOSError(ENOTSUP)
-    
+
     def init(self, path):
         """Called on filesystem initialization. Path is always /
            Use it instead of __init__ if you start threads on initialization."""
         pass
-    
+
     def link(self, target, source):
         raise FuseOSError(EROFS)
-    
+
     def listxattr(self, path):
         return []
-        
+
     lock = None
-    
+
     def mkdir(self, path, mode):
         raise FuseOSError(EROFS)
-    
+
     def mknod(self, path, mode, dev):
         raise FuseOSError(EROFS)
-    
+
     def open(self, path, flags):
         """When raw_fi is False (default case), open should return a numerical
            file handle.
@@ -578,60 +597,60 @@ class Operations(object):
                open(self, path, fi)
            and the file handle should be set directly."""
         return 0
-    
+
     def opendir(self, path):
         """Returns a numerical file handle."""
         return 0
-    
+
     def read(self, path, size, offset, fh):
         """Returns a string containing the data requested."""
         raise FuseOSError(EIO)
-    
+
     def readdir(self, path, fh):
         """Can return either a list of names, or a list of (name, attrs, offset)
            tuples. attrs is a dict as in getattr."""
         return ['.', '..']
-    
+
     def readlink(self, path):
         raise FuseOSError(ENOENT)
-    
+
     def release(self, path, fh):
         return 0
-    
+
     def releasedir(self, path, fh):
         return 0
-    
+
     def removexattr(self, path, name):
         raise FuseOSError(ENOTSUP)
-    
+
     def rename(self, old, new):
         raise FuseOSError(EROFS)
-    
+
     def rmdir(self, path):
         raise FuseOSError(EROFS)
-    
+
     def setxattr(self, path, name, value, options, position=0):
         raise FuseOSError(ENOTSUP)
-    
+
     def statfs(self, path):
         """Returns a dictionary with keys identical to the statvfs C structure
            of statvfs(3).
            On Mac OS X f_bsize and f_frsize must be a power of 2 (minimum 512)."""
         return {}
-    
+
     def symlink(self, target, source):
         raise FuseOSError(EROFS)
-    
+
     def truncate(self, path, length, fh=None):
         raise FuseOSError(EROFS)
-    
+
     def unlink(self, path):
         raise FuseOSError(EROFS)
-    
+
     def utimens(self, path, times=None):
         """Times is a (atime, mtime) tuple. If None use current time."""
         return 0
-    
+
     def write(self, path, data, offset, fh):
         raise FuseOSError(EROFS)
 
diff --git a/snf-pithos-tools/pithos/tools/lib/transfer.py b/snf-pithos-tools/pithos/tools/lib/transfer.py
index ce3b88f..857af9f 100644
--- a/snf-pithos-tools/pithos/tools/lib/transfer.py
+++ b/snf-pithos-tools/pithos/tools/lib/transfer.py
@@ -1,18 +1,18 @@
 # Copyright 2011-2012 GRNET S.A. All rights reserved.
-# 
+#
 # Redistribution and use in source and binary forms, with or
 # without modification, are permitted provided that the following
 # conditions are met:
-# 
+#
 #   1. Redistributions of source code must retain the above
 #      copyright notice, this list of conditions and the following
 #      disclaimer.
-# 
+#
 #   2. Redistributions in binary form must reproduce the above
 #      copyright notice, this list of conditions and the following
 #      disclaimer in the documentation and/or other materials
 #      provided with the distribution.
-# 
+#
 # THIS SOFTWARE IS PROVIDED BY GRNET S.A. ``AS IS'' AND ANY EXPRESS
 # OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 # WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
@@ -25,7 +25,7 @@
 # LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
 # ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 # POSSIBILITY OF SUCH DAMAGE.
-# 
+#
 # The views and conclusions contained in the software and
 # documentation are those of the authors and should not be
 # interpreted as representing official policies, either expressed
@@ -42,20 +42,21 @@ from client import Fault
 
 from progress.bar import IncrementalBar
 
+
 def upload(client, path, container, prefix, name=None, mimetype=None):
-    
+
     meta = client.retrieve_container_metadata(container)
     blocksize = int(meta['x-container-block-size'])
     blockhash = meta['x-container-block-hash']
-    
+
     size = os.path.getsize(path)
     hashes = HashMap(blocksize, blockhash)
     hashes.load(open(path))
     map = {'bytes': size, 'hashes': [hexlify(x) for x in hashes]}
-    
+
     objectname = name if name else os.path.split(path)[-1]
     object = prefix + objectname
-    kwargs = {'mimetype':mimetype} if mimetype else {}
+    kwargs = {'mimetype': mimetype} if mimetype else {}
     v = None
     try:
         v = client.create_object_by_hashmap(container, object, map, **kwargs)
@@ -64,15 +65,15 @@ def upload(client, path, container, prefix, name=None, mimetype=None):
             raise
     else:
         return v
-    
-    if type(fault.data) == types.StringType:
+
+    if isinstance(fault.data, types.StringType):
         missing = json.loads(fault.data)
-    elif type(fault.data) == types.ListType:
+    elif isinstance(fault.data, types.ListType):
         missing = fault.data
-    
+
     if '' in missing:
         del missing[missing.index(''):]
-    
+
     bar = IncrementalBar('Uploading', max=len(missing))
     bar.suffix = '%(percent).1f%% - %(eta)ds'
     with open(path) as fp:
@@ -83,17 +84,18 @@ def upload(client, path, container, prefix, name=None, mimetype=None):
             client.update_container_data(container, StringIO(block))
             bar.next()
     bar.finish()
-    
+
     return client.create_object_by_hashmap(container, object, map, **kwargs)
 
+
 def download(client, container, object, path):
-    
+
     res = client.retrieve_object_hashmap(container, object)
     blocksize = int(res['block_size'])
     blockhash = res['block_hash']
     bytes = res['bytes']
     map = res['hashes']
-    
+
     if os.path.exists(path):
         h = HashMap(blocksize, blockhash)
         h.load(open(path))
@@ -101,7 +103,7 @@ def download(client, container, object, path):
     else:
         open(path, 'w').close()     # Create an empty file
         hashes = []
-    
+
     with open(path, 'a+') as fp:
         if bytes != 0:
             for i, h in enumerate(map):
@@ -109,7 +111,8 @@ def download(client, container, object, path):
                     continue
                 start = i * blocksize
                 end = '' if i == len(map) - 1 else ((i + 1) * blocksize) - 1
-                data = client.retrieve_object(container, object, range='bytes=%s-%s' % (start, end))
+                data = client.retrieve_object(
+                    container, object, range='bytes=%s-%s' % (start, end))
                 if i != len(map) - 1:
                     data += (blocksize - len(data)) * '\x00'
                 fp.seek(start)
